
; Copyright 2021 Mark Woodmass

; This program is licensed under the GNU General Public License. See the
; file `COPYING' for details

; Only compatible on ZX Spectrum 128K/+2

                        org   50000

                        jp    start

                        include     execcycle.asm

start                   proc
                        xor   a
                        call  8859
                        ld    a,7
                        ld    (23693),a
                        call  3435
                        ld    a,2
                        call  #1601

                        ld    a,22
                        rst   16
                        xor   a
                        rst   16
                        xor   a
                        rst   16
                        ld    de,string_numerics
                        call  print_text

                        ld    a,1
                        call  #1601
                        ld    a,22
                        rst   16
                        ld    a,2
                        rst   16
                        xor   a
                        rst   16
                        ld    de,string_numerics
                        call  print_text

                        ld    a,2
                        call  #1601

                        ld    a,24
                        ld    de,22528
      _copy_attr_line   ld    hl,pattern_attributes
                        ld    bc,32
                        ldir
                        dec   a
                        jr    nz,_copy_attr_line

                        call  create_pattern


                        ret
                        endp

create_pattern          proc

pattern_start           equ   (228*15)-102
                        ld    hl,pattern_start        ; cycle to hit target address at
                        ld    ix,pattern_loop_int     ; ix = target address
                        ld    de,default_exit_int     ; post-test exit interrupt address
                        call  exec_cycle_128k         ; run the test

                        ret
                        endp

pattern_loop_int        proc

      _frame_start      di

                        ld    de,#0201
                        ld    hl,#0403
                        ld    bc,#00fe

;                       =======================================
                        ld    b,48

      _top_loop         ld    d,2
                        ld    d,d

; top border
; first OUT at 3370

                        out   (c),d       ; red
                        nop
                        out   (c),e       ; blue
                        nop
                        out   (c),h       ; green
                        nop
                        out   (c),l       ; magenta
                        nop

                        out   (c),d       ; red
                        nop
                        out   (c),e       ; blue
                        nop
                        db    $ed,$71     ; out (c),0
                        nop
                        out   (c),e       ; blue
                        nop
                        out   (c),d       ; red
                        nop

                        out   (c),l       ; magenta
                        nop
                        out   (c),h       ; green
                        nop
                        out   (c),e       ; blue
                        nop
                        out   (c),d       ; red

                        djnz  _top_loop

;                       =======================================
                        ld    b,192

                        or    a           ; clear Carry

      _paper_loop       
; paper
; first OUT at 14314
; last  OUT at 14506 on first scanline
                        ret   c

                        out   (c),d       ; red
                        nop
                        out   (c),e       ; blue
                        nop
                        out   (c),h       ; green

                        ld    ix,0
                        inc   sp
                        ld    ix,(0)
                        ld    ix,(0)
                        ld    ix,(0)
                        ld    ix,(0)
                        bit   0,a
                        bit   0,a
                        bit   0,a         ; 8t
                        nop
                        nop

                        out   (c),e       ; blue
                        or    a           ; clear Carry
                        out   (c),d       ; red             ; 14506

                        dec   sp

                        djnz  _paper_loop

;                       =======================================
                        ld    bc,#30fe
      _bottom_loop      

;  bottom border
; first OUT at 58090

                        out   (c),d       ; red
                        nop
                        out   (c),e       ; blue
                        nop
                        out   (c),h       ; green
                        nop
                        out   (c),l       ; magenta
                        nop

                        out   (c),d       ; red
                        nop
                        out   (c),e       ; blue
                        nop
                        db    $ed,$71     ; out (c),0
                        nop
                        out   (c),e       ; blue
                        nop
                        out   (c),d       ; red
                        nop

                        out   (c),l       ; magenta
                        nop
                        out   (c),h       ; green
                        nop
                        out   (c),e       ; blue
                        nop
                        out   (c),d       ; red

                        ld    d,2
                        ld    d,d

                        djnz  _bottom_loop




                        xor   a
                        in    a,(254)
                        and   31
                        cp    31
                        jr    nz,_exit

                        ld    hl,5151-10
                        call  delay
                        jp    _frame_start


      _exit             ld    hl,#2758
                        exx
                        ei
                        halt


                        ret
                        endp

                        include     delay.asm
                        include     print.asm

pattern_attributes      db    8*4+7, 8*4+7
                        db    8*3+7, 8*3+7, 8*3+7, 8*3+7
                        db    8*2+7, 8*2+7, 8*2+7, 8*2+7
                        db    8*1+7, 8*1+7, 8*1+7, 8*1+7
                        db    8*0+7, 8*0+7, 8*0+7, 8*0+7
                        db    8*1+7, 8*1+7, 8*1+7, 8*1+7
                        db    8*2+7, 8*2+7, 8*2+7, 8*2+7
                        db    8*3+7, 8*3+7, 8*3+7, 8*3+7
                        db    8*4+7, 8*4+7


string_numerics         db    "01234567890123456789012345678901",255

                        end   start


